import sys
import numpy as np
import matplotlib.pyplot as plt

pyscript = sys.argv[0]
fname = str(sys.argv[1])+"/"+str(sys.argv[2])

print("{} is processing file {}".format(pyscript,fname)

f = np.genfromtxt(fname,delimiter=",")
Lt = f[:,0]
Rmode = f[:,1]
Rflux = f[:,2]

plt.figure(dpi=150)
plt.loglog(Lt,Rmode,'bo-',label='mode decomposition')
plt.loglog(Lt,Rflux,'ro-',label='flux')
plt.loglog(Lt,0.005/Lt**2,'k-',label=r'quadratic reference (1/Lt$^2$)')
plt.legend(loc='upper right')
plt.xlabel('taper length Lt (μm)')
plt.ylabel('reflectance')

out = str(sys.argv[1])+"/Reflectance.png"
plt.savefig(out,dpi=100)

#plt.show()

