#!/bin/bash

DATE=`date '+%Y%m%d_%H%M%S'`

name_ext=lab4 # gs = gaussian source, (pw = plane wave) - pw not applicable here!
this=run
name=lin_taper
rerun=rerun

# PUT YOUR OUTPUT DIRECTORY HERE!
# EASIEST WAY IS TO SET TO .
meep_data=<PLACEHOLDER>
base_dir=${meep_data}/${name}_${name_ext}
data_dir=${base_dir}

mkdir ${base_dir}

# save script and parms
# ----------------------------
mkdir ${base_dir}/.${DATE}
cp ./${name}.py ${base_dir}/.${DATE}/${name}_${DATE}.py
cp ./${this}.sh ${base_dir}/.${DATE}/${this}_${DATE}.py
cp ./${scale}.sh ${base_dir}/.${DATE}/${scale}_${DATE}.py

# cell size [um x um] and 
# resolution [samples per um]
# ----------------------------
res=<PLACEHOLDER>
nfreq=<PLACEHOLDER>

# Taper parms
# PUT YOUR DESIGN PARMS HERE!!
# ----------------------------
<PLACEHOLDER>
# Example (List)        : wg_Len=(1) # Waveguide length
# Example (Single Param): d_pmlY=0.5 # PML diameter in y-direction

# Source
# PUT YOUR DESIGN PARMS HERE!!
# ----------------------------
<PLACEHOLDER>
# Example (Single Param) : df=0.4
# Example (List)         : src_theta=(0)


# DEFINE FOR-LOOPS TO SWEEP PARAMETERS
# TAKE TIME TO UNDERSTAND THE PRINCIPLE (!!) AND
# ... THEN ADAPT FOR YOUR PURPOSE
<PLACEHOLDER>
for wl in ${wg_Len[@]}; do
    for tl in ${tp_Len[@]}; do
	for wi in ${tp_Win[@]}; do
	    for wo in ${tp_Wout[@]}; do
		ext=wl${wl}_tl${tl}_wi${wi}_wo${wo}
		dir=${data_dir}/${ext}
		echo "*** Creating directory $dir"
		mkdir -p ${dir}
		cp ./${this}.sh ${dir}
		cp ./${name}.py ${dir}
		cp ./${scale}.sh ${dir}
		touch ${dir}/${this}.out;
		mv ${dir}/${this}.out ${dir}/.${this}.saved_${DATE}.out;
		echo "#!/bin/bash" > ${dir}/${rerun}.sh;
		echo "mkdir rerun" > ${dir}/${rerun}.sh;
                # PUT ALL YOUR PARAMETES HERE, WHEN lin_taper.py is called
		echo "python -u ${name}.py -dir ${rerun} -fcen ${fcen} -df ${df} -res ${res} -nfreq ${nfreq} <PLACEHOLDER> 2>&1 | tee -a ./${rerun}/${rerun}.out;" \
		    | tee ${dir}/${rerun}.sh;
                # DO SOME GREP TO SPLIT DATA FOR ANALYSIS. NO WORRIES, JUST USE AS IT IS ... 
                # SHOULD DO THE JOB PROPERLY IF YOU DID NOT CHANGE ANALYSIS SECTIONS OF lin_taper.py
		echo "grep -e \"^i:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_fluxI.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^t:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_fluxT.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^l:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_fluxL.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^e:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_fluxE.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^s:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_Summary.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^eigModes:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_eigModes.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^modeFlux:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_modeFlux.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^poyntingFlux:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_poyntingFlux.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^refl:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_refl.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "grep -e \"^tran:\" ./${rerun}/${rerun}.out | cut -d , -f2- > ./${rerun}/${rerun}_tran.dat;" \
		    | tee -a ${dir}/${rerun}.sh;
		echo "**** TANH Taper:  ****" \
		    | tee ${dir}/${this}.out;
		echo "*** ${this} :" \
		    | tee -a ${dir}/${this}.out;
		echo "python -u ${name}.py -dir ${rerun} -fcen ${fcen} -df ${df} -res ${res} -nfreq ${nfreq} -tol ${tol} -wg_Len ${wl} -tp_Len ${tl} -tp_Win ${wi} -tp_Wout ${wo} 2>&1 | tee -a ${dir}/${this}.out;" \
		    | tee -a ${dir}/${this}.out;
		python -u ${name}.py \
		    -d_pmlX ${d_pmlX} -d_pmlY ${d_pmlY} -d_Air ${d_Air} \
		    -fcen ${fcen} -df ${df} \
		    -res ${res} -nfreq ${nfreq} -tol ${tol} \
		    -dir ${dir} \
		    -wg_Len ${wl} -tp_Len ${tl} -tp_Win ${wi} -tp_Wout ${wo} \
		    2>&1 | tee -a ${dir}/${this}.out;
		grep -e "^i:" ${dir}/${this}.out | cut -d , -f2- > ${dir}/fluxIncident.dat
		grep -e "^t:" ${dir}/${this}.out | cut -d , -f2- > ${dir}/fluxTransmitted.dat
		grep -e "^l:" ${dir}/${this}.out | cut -d , -f2- > ${dir}/fluxLoss.dat
		grep -e "^e:" ${dir}/${this}.out | cut -d , -f2- > ${dir}/fluxErr.dat
		grep -e "^s:" ${dir}/${this}.out | cut -d , -f2- > ${dir}/fluxSummary.dat
		grep -e "^modeFlux:" ${dir}/${this}.out | cut -d , -f2- | tee ${dir}/modeFlux.dat
		grep -e "^eigModes(R):" ${dir}/${this}.out | cut -d , -f2- | tee ${dir}/eigModesR.dat
		grep -e "^eigModes(T):" ${dir}/${this}.out | cut -d , -f2- | tee ${dir}/eigModesT.dat
		grep -e "^refl:" ${dir}/${this}.out | cut -d , -f2- | tee -a ${data_dir}/reflSummaryAll.dat
		grep -e "^tran:" ${dir}/${this}.out | cut -d , -f2- | tee -a ${data_dir}/tranSummaryAll.dat
		#python -u post_proc.py ${dir} ${this}.dat
	    done
	done
    done
done


